/**
  ******************************************************************************
  * @file    main.c
  * @author  MCU Application Team
  * @brief   Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2023 Puya Semiconductor Co.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by Puya under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2016 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "py32f420_ll_epwm.h"

/* Private define ------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private user code ---------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
static void APP_SystemClockConfig(void);

/**
  * @brief  Main program.
  * @retval int
  */
int main(void)
{
  /* Reset of all peripherals, Initializes the Systick. */
  HAL_Init();
  
  /* Configure system clock */
  APP_SystemClockConfig(); 
  
  /* Configure EPWM GPIO */
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
  GPIO_InitTypeDef   GPIO_InitStruct = {0};
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  /* EPWM1_PWMA */
  GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_InitStruct.Alternate = GPIO_AF11_EPWM;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);
  /* EPWM2_PWMA */
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_InitStruct.Alternate = GPIO_AF11_EPWM;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
  /* EPWM3_PWMA */
  GPIO_InitStruct.Pin = GPIO_PIN_12;
  GPIO_InitStruct.Alternate = GPIO_AF11_EPWM;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);
  
  /* Enable EPWM peripheral clock */
  __HAL_RCC_EPWM_CLK_ENABLE();
  while(!__HAL_RCC_GET_FLAG(RCC_FLAG_EPWM_PRST));
  while(!__HAL_RCC_GET_FLAG(RCC_FLAG_EPWM_SFTRST));
  /* Enable EPWMs TBCTR clock */
  __HAL_RCC_EPWM_TIME_BASE_SYNC_ENABLE();
  
  /* Unlocks all EPWM common register and part of EPWMx register */
  LL_EPWM_EALLOW(EPWMC);
  
  /* Sets up the Action Qualifier output */
  LL_EPWM_AQ_ConfigActionComplete(EPWM1, LL_EPWM_AQ_OUTPUT_A, (LL_EPWM_AQ_OUTPUT_LOW_UP_CMPA | LL_EPWM_AQ_OUTPUT_HIGH_ZERO));
  /* Select the SYNCO output event for EPWM1*/
  LL_EPWM_SetSyncOutPulseMode(EPWM1, LL_EPWM_SYNC_OUT_PULSE_ON_CNTR_ZERO);
  
  /* Sets up the Action Qualifier output */
  LL_EPWM_AQ_ConfigActionComplete(EPWM2, LL_EPWM_AQ_OUTPUT_A, (LL_EPWM_AQ_OUTPUT_LOW_UP_CMPA | LL_EPWM_AQ_OUTPUT_HIGH_ZERO));
  /* Select the SYNCI input source for EPWM2*/
  LL_EPWM_SetSYNCISource(EPWMC, LL_EPWM_SYNC_SEL2, 0x3);
  LL_EPWM_EnablePhaseShiftLoad(EPWM2);
  
  /* Sets up the Action Qualifier output */
  LL_EPWM_AQ_ConfigActionComplete(EPWM3, LL_EPWM_AQ_OUTPUT_A, (LL_EPWM_AQ_OUTPUT_LOW_UP_CMPA | LL_EPWM_AQ_OUTPUT_HIGH_ZERO));
  /* Select the SYNCI input source for EPWM3*/
  LL_EPWM_SetSYNCISource(EPWMC, LL_EPWM_SYNC_SEL3, 0x3);
  LL_EPWM_EnablePhaseShiftLoad(EPWM3);
  
  /* Time Base , counter compare and phase shift offset configuration */
  LL_EPWM_SetPeriod(EPWM2, (120 - 1));
  LL_EPWM_SetClockPrescaler(EPWM2, LL_EPWM_CLOCK_DIVIDER_1, LL_EPWM_HSCLOCK_DIVIDER_1);
  LL_EPWM_SetCompareA(EPWM2, (60 - 1));
  LL_EPWM_SetPhaseShift(EPWM2, (120 - 1)*0U/360U);
  LL_EPWM_SetCounterMode(EPWM2, LL_EPWM_CNTR_MODE_UP);
  
  /* Time Base , counter compare and phase shift offset configuration */
  LL_EPWM_SetPeriod(EPWM3, (120 - 1));
  LL_EPWM_SetClockPrescaler(EPWM3, LL_EPWM_CLOCK_DIVIDER_1, LL_EPWM_HSCLOCK_DIVIDER_1);
  LL_EPWM_SetCompareA(EPWM3, (60 - 1));
  LL_EPWM_SetPhaseShift(EPWM3, (120 - 1)*0U/360U);
  LL_EPWM_SetCounterMode(EPWM3, LL_EPWM_CNTR_MODE_UP);
  
  /* Time Base and counter compare configuration */
  LL_EPWM_SetPeriod(EPWM1, (120 - 1));
  LL_EPWM_SetClockPrescaler(EPWM1, LL_EPWM_CLOCK_DIVIDER_1, LL_EPWM_HSCLOCK_DIVIDER_1);
  LL_EPWM_SetCompareA(EPWM1, (60 - 1));
  LL_EPWM_SetCounterMode(EPWM1, LL_EPWM_CNTR_MODE_UP);
  
  /* Locks all EPWM common register and part of EPWMx register */
  LL_EPWM_EDIS(EPWMC);
  
  /* Infinite loop */
  while (1)
  {
    
  }
}

/**
  * @brief  System Clock Configuration
  * @param  None
  * @retval None
  */
static void APP_SystemClockConfig(void)
{
  RCC_OscInitTypeDef  OscInitstruct = {0};
  RCC_ClkInitTypeDef  ClkInitstruct = {0};
  
  OscInitstruct.OscillatorType      = RCC_OSCILLATORTYPE_HSE | RCC_OSCILLATORTYPE_HSI | RCC_OSCILLATORTYPE_LSE | 
                                      RCC_OSCILLATORTYPE_LSI;
  OscInitstruct.HSIState            = RCC_HSI_ON;                               /* Enable HSI */
  OscInitstruct.HSIDiv              = RCC_HSI_DIV1;                             /* HSI 1 frequency division */
  OscInitstruct.HSICalibrationValue = RCC_HSICALIBRATION_8MHz;                  /* Configure HSI clock 8MHz */
  OscInitstruct.HSEState            = RCC_HSE_ON;                               /* Enable HSE */
  OscInitstruct.HSEFreq             = RCC_HSE_16_24MHz;                         /* Choose HSE frequency of 16-24MHz */
  OscInitstruct.LSEState            = RCC_LSE_OFF;                              /* Close LSE */
/* OscInitstruct.LSEDriver           = RCC_LSEDRIVE_HIGH; */                    /* Drive capability level: high */
  OscInitstruct.LSIState            = RCC_LSI_OFF;                              /* Close LSI */
  OscInitstruct.PLL.PLLState        = RCC_PLL_ON;                               /* Enable PLL */
  OscInitstruct.PLL.PLLSource       = RCC_PLLSOURCE_HSE;                        /* PLL clock source selection HSE */
  OscInitstruct.PLL.PLLMUL          = RCC_PLL_MUL5;                             /* PLL clock source 5-fold frequency */
  /* Configure oscillator */
  if(HAL_RCC_OscConfig(&OscInitstruct) != HAL_OK)
  {
    APP_ErrorHandler();
  }
  
  ClkInitstruct.ClockType       = RCC_CLOCKTYPE_SYSCLK | RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2;
  ClkInitstruct.SYSCLKSource    = RCC_SYSCLKSOURCE_PLLCLK;              /* System clock selection PLL */
  ClkInitstruct.AHBCLKDivider   = RCC_SYSCLK_DIV1;                      /* AHB clock 1 division */
  ClkInitstruct.APB1CLKDivider  = RCC_HCLK_DIV1;                        /* APB1 clock 1 division */
  ClkInitstruct.APB2CLKDivider  = RCC_HCLK_DIV1;                        /* APB2 clock 1 division */
  /* Configure Clock */
  if(HAL_RCC_ClockConfig(&ClkInitstruct, FLASH_LATENCY_4) != HAL_OK)
  {
    APP_ErrorHandler();
  }
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void APP_ErrorHandler(void)
{
  /* Infinite loop */
  while (1)
  {
  }
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     for example: printf("Wrong parameters value: file %s on line %d\r\n", file, line)  */
  /* Infinite loop */
  while (1)
  {
  }
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT Puya *****END OF FILE******************/
